#!/usr/bin/python
# -*- coding: UTF-8 -*-
from __future__ import absolute_import
from __future__ import with_statement
from __future__ import division
from __future__ import print_function

'''
Python code to rebuild the index, sice github pages doesn't provide
browsing links automatically
'''

import os,sys
#eg = [e for e in os.listdir('./examples/') if '.html' in e]

# only overwrite index files previously generated by maketree
autogensig = "Autogenerated by maketree.py"


template = '''
<html>
<head>
<!-- %(autogensig)s -->
</head>
<body>
<h3>Index of %(foldername)s</h3>
%(content)s
</body>
</html>
'''

verbose = False

scriptfile = sys.argv[0]
if verbose: print('script at: ',scriptfile)

foldername = os.path.relpath(".","..")#os.getcwd()

import locale
from functools import cmp_to_key
import re
def natural_key(string_):
    """See http://www.codinghorror.com/blog/archives/001018.html"""
    return [int(s) if s.isdigit() else s for s in re.split(r'(\d+)', string_)]


dirlist  = ''
filelist = ''

for f in os.listdir('.'):
    # Ignore . files
    if f[0]=='.': continue
    if f[-1]=='~': continue
    if os.path.isdir('./'+f):
        if verbose: 
            print(f)
            print('dir')
        os.chdir(f)
        cmd = '../'+scriptfile
        if verbose: 
            print(cmd)
        os.system(cmd)
        os.chdir('../')
        dirlist+='<a href="./%(f)s/index.html">./%(f)s</a><br/>'%globals()
    elif os.path.os.path.isfile('./'+f):
        if f=="index.html": continue
        #if verbose: 
        #       print('file')
        filelist+='<a href="./%(f)s">%(f)s</a><br/>'%globals()
    else:
        if verbose: print('unknown!?')

content = dirlist + filelist

overwrite = True
try:
    # https://stackoverflow.com/questions/4940032/search-for-string-in-txt-file-python
    with open('index.html','r') as index:
        if not autogensig in index.read():
            overwrite = False
            if verbose: 
                print('Found existing index.html file that was not generated by maketree.py')
                print('Will not overwrite, skipping')
        else:
            if verbose:
                print('index.html exists, but was generated by maketree.py; updating')
except:
    pass
if overwrite:
    with open("index.html", "w") as index:
        index.write(template%globals())

if verbose: print("done")
